// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/ui/UIComponent.hpp"

namespace Dawn {
  class UISimpleMenuItem : public SceneItemComponent {
    public:
      StateEvent<> eventHoveredOn;
      StateEvent<> eventHoveredOff;
      StateEvent<> eventSelected;
      // May make these into either state events or make a new event.
      int32_t menuX = 0;
      int32_t menuY = 0;
      UIComponent *uiComponent = nullptr;

      UISimpleMenuItem(SceneItem *item);

      /**
       * Returns the UI component that this simple UI menu item uses to figure
       * out if it is being hovered over currently or not.
       * 
       * @return UI Component to use for highlighting / hovering.
       */
      virtual UIComponent * getComponentForHighlighting();
  };
}