// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "asset/IAssetLoader.hpp"

namespace Dawn {
  class AssetLoader : public IAssetLoader {
    private:
      FILE *handle;
      size_t size;

    public:
      AssetLoader(std::string filename);
      void open() override;
      int32_t close() override;
      size_t read(uint8_t *buffer, size_t size) override;
      size_t getSize() override;
      size_t skip(size_t n) override;
      void rewind() override;
      size_t getPosition() override;
      ~AssetLoader();
  };
}