// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/Shader.hpp"
#include "display/shader/buffers/RenderPipelineShaderBuffer.hpp"

#define UI_SHADER_PROGRAM_PRIORITY 1000

namespace Dawn {
  SHADER_PARAMETER_BUFFER_DEFINE(UICanvasShaderBuffer, \
    SHADER_PARAMETER_BUFFER_MAT4(projection);
    SHADER_PARAMETER_BUFFER_MAT4(view);
  );
  
  class UIShader : public Shader {
    public:
      shaderparameter_t paramModel;
      shaderparameter_t paramColor;
      shaderparameter_t paramTexture;
      shaderparameter_t paramHasTexture;
      shaderbufferlocation_t bufferUiCanvas;

      void compile() override;
  };
}